diff -urN cad/salome-yacs.orig/Makefile cad/salome-yacs/Makefile
--- cad/salome-yacs.orig/Makefile	2010-02-12 23:17:05.000000000 +0100
+++ cad/salome-yacs/Makefile	2010-05-02 22:50:35.000000000 +0200
@@ -4,11 +4,11 @@
 #
 # $FreeBSD: ports/cad/salome-yacs/Makefile,v 1.1 2010/02/12 22:17:05 pgollucci Exp $
 
-CATEGORIES=     cad science
+CATEGORIES=	cad science
 
-MASTERDIR=      ${.CURDIR}/../salome
+MASTERDIR=	${.CURDIR}/../salome
 
-PKGNAMESUFFIX=  -yacs
+PKGNAMESUFFIX=	-yacs
 SAL_MODULE_UPPER=	YACS
 
 .include "${MASTERDIR}/Makefile"
diff -urN cad/salome-yacs.orig/files/patch-adm_unix_make_begin.am cad/salome-yacs/files/patch-adm_unix_make_begin.am
--- cad/salome-yacs.orig/files/patch-adm_unix_make_begin.am	1970-01-01 01:00:00.000000000 +0100
+++ cad/salome-yacs/files/patch-adm_unix_make_begin.am	2010-05-02 22:44:27.000000000 +0200
@@ -0,0 +1,8 @@
+--- adm/unix/make_begin.am.orig	2010-04-09 19:23:41.000000000 +0700
++++ adm/unix/make_begin.am	2010-04-09 19:23:52.000000000 +0700
+@@ -47,4 +47,4 @@
+ 
+ # translation (*.qm) files generation (lrelease)
+ %.qm: resources/%.ts
+-	$(QT_DIR)/bin/lrelease $< -qm $@
++	$(QT_DIR)/bin/lrelease-qt4 $< -qm $@
diff -urN cad/salome-yacs.orig/files/patch-doc_Makefile.am cad/salome-yacs/files/patch-doc_Makefile.am
--- cad/salome-yacs.orig/files/patch-doc_Makefile.am	1970-01-01 01:00:00.000000000 +0100
+++ cad/salome-yacs/files/patch-doc_Makefile.am	2010-05-02 22:34:19.000000000 +0200
@@ -0,0 +1,11 @@
+--- doc/Makefile.am.orig	2010-04-17 22:44:37.000000000 +0700
++++ doc/Makefile.am	2010-04-17 22:44:43.000000000 +0700
+@@ -24,7 +24,7 @@
+ 
+ yacsdoc_DATA=html/index.html
+ html/index.html:$(RSTFILES)
+-	make htm
++	gmake htm
+ 
+ endif
+ 
diff -urN cad/salome-yacs.orig/pkg-plist cad/salome-yacs/pkg-plist
--- cad/salome-yacs.orig/pkg-plist	2010-02-12 23:17:05.000000000 +0100
+++ cad/salome-yacs/pkg-plist	2010-05-02 22:37:41.000000000 +0200
@@ -358,6 +358,274 @@
 lib/salome/libYACSloader.la
 lib/salome/libYACSloader.so
 lib/salome/libYACSloader.so.0
+share/doc/salome/gui/YACS/accesCorba.html
+share/doc/salome/gui/YACS/accesLocal.html
+share/doc/salome/gui/YACS/advancepy.html
+share/doc/salome/gui/YACS/annexe_common.html
+share/doc/salome/gui/YACS/batch.html
+share/doc/salome/gui/YACS/calcium.html
+share/doc/salome/gui/YACS/calculator.html
+share/doc/salome/gui/YACS/compInterne.html
+share/doc/salome/gui/YACS/components.html
+share/doc/salome/gui/YACS/console.html
+share/doc/salome/gui/YACS/cppsalome.html
+share/doc/salome/gui/YACS/dataflow.html
+share/doc/salome/gui/YACS/etapes.html
+share/doc/salome/gui/YACS/execpy.html
+share/doc/salome/gui/YACS/execution.html
+share/doc/salome/gui/YACS/execxml.html
+share/doc/salome/gui/YACS/genindex.html
+share/doc/salome/gui/YACS/gui.html
+share/doc/salome/gui/YACS/gui_components.html
+share/doc/salome/gui/YACS/hxx2salome.html
+share/doc/salome/gui/YACS/index.html
+share/doc/salome/gui/YACS/integration.html
+share/doc/salome/gui/YACS/main_menu.html
+share/doc/salome/gui/YACS/modification.html
+share/doc/salome/gui/YACS/objects.inv
+share/doc/salome/gui/YACS/operations.html
+share/doc/salome/gui/YACS/optimizer.html
+share/doc/salome/gui/YACS/principes.html
+share/doc/salome/gui/YACS/progdsc.html
+share/doc/salome/gui/YACS/pysalome.html
+share/doc/salome/gui/YACS/python.html
+share/doc/salome/gui/YACS/rappels.html
+share/doc/salome/gui/YACS/references.html
+share/doc/salome/gui/YACS/representation.html
+share/doc/salome/gui/YACS/salome.html
+share/doc/salome/gui/YACS/schemapy.html
+share/doc/salome/gui/YACS/schemaxml.html
+share/doc/salome/gui/YACS/scratch.html
+share/doc/salome/gui/YACS/search.html
+share/doc/salome/gui/YACS/searchindex.js
+share/doc/salome/gui/YACS/toolbars.html
+share/doc/salome/gui/YACS/using.html
+share/doc/salome/gui/YACS/yacsgen.html
+share/doc/salome/gui/YACS/_images/100000000000021500000199FE12879E.png
+share/doc/salome/gui/YACS/_images/100000000000030C00000270AD87A128.png
+share/doc/salome/gui/YACS/_images/10000000000003210000012BF34ED8EC.png
+share/doc/salome/gui/YACS/_images/1000000000000321000002300A9186FC.png
+share/doc/salome/gui/YACS/_images/2d_viewer_0.png
+share/doc/salome/gui/YACS/_images/accesCorba.png
+share/doc/salome/gui/YACS/_images/accesCorbaIDL.png
+share/doc/salome/gui/YACS/_images/accesLocal.png
+share/doc/salome/gui/YACS/_images/accesLocalCpp.png
+share/doc/salome/gui/YACS/_images/block_node.png
+share/doc/salome/gui/YACS/_images/calcium1.png
+share/doc/salome/gui/YACS/_images/catalogs.png
+share/doc/salome/gui/YACS/_images/common0.png
+share/doc/salome/gui/YACS/_images/common1.png
+share/doc/salome/gui/YACS/_images/common2.png
+share/doc/salome/gui/YACS/_images/component.png
+share/doc/salome/gui/YACS/_images/container.png
+share/doc/salome/gui/YACS/_images/conteneur.png
+share/doc/salome/gui/YACS/_images/control_link.png
+share/doc/salome/gui/YACS/_images/data_link.png
+share/doc/salome/gui/YACS/_images/ex1.png
+share/doc/salome/gui/YACS/_images/functionality_list_0.png
+share/doc/salome/gui/YACS/_images/functionality_list_1.png
+share/doc/salome/gui/YACS/_images/functionality_list_10.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_100.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_101.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_101a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_102.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_103.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_104.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_105.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_106.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_107.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_108.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_11.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_12.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_16.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_18.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_19.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_19a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_2.png
+share/doc/salome/gui/YACS/_images/functionality_list_20.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_21.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_22.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_23.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_24.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_25.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_27.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_3.png
+share/doc/salome/gui/YACS/_images/functionality_list_30.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_31.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_32.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_33.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_34.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_35.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_36.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_37.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_38.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_39.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_4.png
+share/doc/salome/gui/YACS/_images/functionality_list_40.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_41.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_42.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_43.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_44.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_45.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_46.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_47.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_47a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_47b.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_47c.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_47d.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_48.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_49.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_5.png
+share/doc/salome/gui/YACS/_images/functionality_list_50.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_51.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_52.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_53.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_54.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_55.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_56.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_57.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_58.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_59.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_6.png
+share/doc/salome/gui/YACS/_images/functionality_list_60.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_60a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_60b.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_61.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_61a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_62.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_64.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_65.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_65a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_66.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_67.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_68.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_69.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_6a.png
+share/doc/salome/gui/YACS/_images/functionality_list_6b.png
+share/doc/salome/gui/YACS/_images/functionality_list_6c.png
+share/doc/salome/gui/YACS/_images/functionality_list_7.png
+share/doc/salome/gui/YACS/_images/functionality_list_70.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_71.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_72.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_73.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_74.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_75.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_76.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_77.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_77a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_79.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_8.png
+share/doc/salome/gui/YACS/_images/functionality_list_80.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_81.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_82.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_82a.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_83.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_84.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_85.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_86.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_87.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_88.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_89.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_9.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_90.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_92.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_94.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_95.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_96.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_98.jpg
+share/doc/salome/gui/YACS/_images/functionality_list_99.jpg
+share/doc/salome/gui/YACS/_images/general_architecture_0.jpg
+share/doc/salome/gui/YACS/_images/ihm.png
+share/doc/salome/gui/YACS/_images/in_port.png
+share/doc/salome/gui/YACS/_images/input_panel_0.png
+share/doc/salome/gui/YACS/_images/input_panel_1.png
+share/doc/salome/gui/YACS/_images/loop_node.png
+share/doc/salome/gui/YACS/_images/main_menu_0.png
+share/doc/salome/gui/YACS/_images/main_menu_10.png
+share/doc/salome/gui/YACS/_images/main_menu_11.png
+share/doc/salome/gui/YACS/_images/main_menu_12.png
+share/doc/salome/gui/YACS/_images/main_menu_2.png
+share/doc/salome/gui/YACS/_images/main_menu_3.png
+share/doc/salome/gui/YACS/_images/main_menu_4.png
+share/doc/salome/gui/YACS/_images/main_menu_5.png
+share/doc/salome/gui/YACS/_images/main_menu_6a.png
+share/doc/salome/gui/YACS/_images/main_menu_6b.png
+share/doc/salome/gui/YACS/_images/main_menu_6c.png
+share/doc/salome/gui/YACS/_images/node.png
+share/doc/salome/gui/YACS/_images/objCorbaCpp.png
+share/doc/salome/gui/YACS/_images/objCorbapy.png
+share/doc/salome/gui/YACS/_images/objectBrowser.png
+share/doc/salome/gui/YACS/_images/objint1.png
+share/doc/salome/gui/YACS/_images/objint2.png
+share/doc/salome/gui/YACS/_images/objint3.png
+share/doc/salome/gui/YACS/_images/objintcpp.png
+share/doc/salome/gui/YACS/_images/objintpy.png
+share/doc/salome/gui/YACS/_images/out_port.png
+share/doc/salome/gui/YACS/_images/parallele.png
+share/doc/salome/gui/YACS/_images/phases.png
+share/doc/salome/gui/YACS/_images/progdsc_img1.png
+share/doc/salome/gui/YACS/_images/progdsc_img2.png
+share/doc/salome/gui/YACS/_images/schema.png
+share/doc/salome/gui/YACS/_images/scratch1.jpg
+share/doc/salome/gui/YACS/_images/stream_link.png
+share/doc/salome/gui/YACS/_images/switch_node.png
+share/doc/salome/gui/YACS/_images/toolbars_0.png
+share/doc/salome/gui/YACS/_images/toolbars_1.png
+share/doc/salome/gui/YACS/_images/toolbars_2.png
+share/doc/salome/gui/YACS/_images/toolbars_3.png
+share/doc/salome/gui/YACS/_images/toolbars_4.png
+share/doc/salome/gui/YACS/_images/tree_view_1.png
+share/doc/salome/gui/YACS/_images/tree_view_edition.png
+share/doc/salome/gui/YACS/_images/yacs_gui_description_0.png
+share/doc/salome/gui/YACS/_sources/accesCorba.txt
+share/doc/salome/gui/YACS/_sources/accesLocal.txt
+share/doc/salome/gui/YACS/_sources/advancepy.txt
+share/doc/salome/gui/YACS/_sources/annexe_common.txt
+share/doc/salome/gui/YACS/_sources/batch.txt
+share/doc/salome/gui/YACS/_sources/calcium.txt
+share/doc/salome/gui/YACS/_sources/calculator.txt
+share/doc/salome/gui/YACS/_sources/compInterne.txt
+share/doc/salome/gui/YACS/_sources/components.txt
+share/doc/salome/gui/YACS/_sources/console.txt
+share/doc/salome/gui/YACS/_sources/cppsalome.txt
+share/doc/salome/gui/YACS/_sources/dataflow.txt
+share/doc/salome/gui/YACS/_sources/etapes.txt
+share/doc/salome/gui/YACS/_sources/execpy.txt
+share/doc/salome/gui/YACS/_sources/execution.txt
+share/doc/salome/gui/YACS/_sources/execxml.txt
+share/doc/salome/gui/YACS/_sources/gui.txt
+share/doc/salome/gui/YACS/_sources/gui_components.txt
+share/doc/salome/gui/YACS/_sources/hxx2salome.txt
+share/doc/salome/gui/YACS/_sources/index.txt
+share/doc/salome/gui/YACS/_sources/integration.txt
+share/doc/salome/gui/YACS/_sources/main_menu.txt
+share/doc/salome/gui/YACS/_sources/modification.txt
+share/doc/salome/gui/YACS/_sources/operations.txt
+share/doc/salome/gui/YACS/_sources/optimizer.txt
+share/doc/salome/gui/YACS/_sources/principes.txt
+share/doc/salome/gui/YACS/_sources/progdsc.txt
+share/doc/salome/gui/YACS/_sources/pysalome.txt
+share/doc/salome/gui/YACS/_sources/python.txt
+share/doc/salome/gui/YACS/_sources/rappels.txt
+share/doc/salome/gui/YACS/_sources/references.txt
+share/doc/salome/gui/YACS/_sources/representation.txt
+share/doc/salome/gui/YACS/_sources/salome.txt
+share/doc/salome/gui/YACS/_sources/schemapy.txt
+share/doc/salome/gui/YACS/_sources/schemaxml.txt
+share/doc/salome/gui/YACS/_sources/scratch.txt
+share/doc/salome/gui/YACS/_sources/toolbars.txt
+share/doc/salome/gui/YACS/_sources/using.txt
+share/doc/salome/gui/YACS/_sources/yacsgen.txt
+share/doc/salome/gui/YACS/_static/README
+share/doc/salome/gui/YACS/_static/basic.css
+share/doc/salome/gui/YACS/_static/default.css
+share/doc/salome/gui/YACS/_static/doctools.js
+share/doc/salome/gui/YACS/_static/file.png
+share/doc/salome/gui/YACS/_static/jquery.js
+share/doc/salome/gui/YACS/_static/minus.png
+share/doc/salome/gui/YACS/_static/plus.png
+share/doc/salome/gui/YACS/_static/pygments.css
+share/doc/salome/gui/YACS/_static/searchtools.js
 share/salome/resources/yacs/ExecYACS.png
 share/salome/resources/yacs/ModuleYacs.png
 share/salome/resources/yacs/SalomeApp.xml
@@ -570,6 +838,9 @@
 @dirrm share/salome/yacssupervsamples
 @dirrm share/salome/yacssamples
 @dirrm share/salome/resources/yacs
+@dirrm share/doc/salome/gui/YACS/_images
+@dirrm share/doc/salome/gui/YACS/_sources
+@dirrm share/doc/salome/gui/YACS/_static
 @dirrm share/doc/salome/gui/YACS
 @dirrm %%PYTHON_SITELIBDIR%%/salome/eo__POA
 @dirrm %%PYTHON_SITELIBDIR%%/salome/eo