diff -ruN graphics/gnash-devel/Makefile graphics/gnash-devel.new/Makefile
--- graphics/gnash-devel/Makefile	2010-12-04 07:56:38.000000000 -0600
+++ graphics/gnash-devel.new/Makefile	2011-04-13 00:16:43.000000000 -0500
@@ -6,12 +6,11 @@
 #
 
 PORTNAME=	gnash
-PORTVERSION=	20100218
-PORTREVISION=	5
+PORTVERSION=	0.8.9
 CATEGORIES=	graphics
-MASTER_SITES=	http://mirror.amdmi3.ru/distfiles/
+MASTER_SITES=	GNU/${PORTNAME}/${PORTVERSION}/ \
+		http://www.ringofsaturn.com/distfiles/
 PKGNAMESUFFIX=	-devel
-DISTNAME=	${PORTNAME}-trunk-${REVISION}
 
 MAINTAINER=	amdmi3@FreeBSD.org
 COMMENT=	GNU Flash movie player
@@ -23,8 +22,6 @@
 
 CONFLICTS=	gnash-[0-9]*
 
-REVISION=	11957
-
 USE_BZIP2=	yes
 USE_GMAKE=	yes
 GNU_CONFIGURE=	yes
@@ -44,7 +41,7 @@
 		--sysconfdir="${WRKDIR}/etc" \
 		--disable-jemalloc # leads to infinite recursion on FreeBSD
 
-GNASHVER=	trunk
+GNASHVER=	${PORTVERSION}
 CONFIG_FILES=	gnashpluginrc gnashrc
 
 WRKSRC=		${WRKDIR}/${PORTNAME}-${GNASHVER}
@@ -52,12 +49,13 @@
 
 USE_LDCONFIG=	${PREFIX}/lib/gnash
 
-MAN1=		cygnal.1 dumpshm.1 findmicrophones.1 findwebcams.1 \
+MAN1=		cygnal.1 findmicrophones.1 findwebcams.1 \
 		flvdumper.1 gnash.1 gprocessor.1 gtk-gnash.1 kde4-gnash.1 \
 		rtmpget.1 soldumper.1
 
 OPTIONS=	PLUGIN		"Enable browser plugin" on \
 		CYGNAL		"Enable Cygnal media server" off \
+		VAAPI		"VAAPI decoder support (implies ffmpeg)" off \
 		GTK		"GUI: GTK (required for Mozilla/Firefox plugin)" on \
 		KDE		"GUI: KDE 3.x (required for Konqueror 3.x plugin)" off \
 		KDE4		"GUI: KDE 4.x (required for Konqueror 4.x plugin)" off \
@@ -80,6 +78,13 @@
 CONFIGURE_ARGS+=	--disable-cygnal
 .endif
 
+#VAAPI
+.if defined(WITH_VAAPI)
+LIB_DEPENDS+=   va.1:${PORTSDIR}/multimedia/libva
+LIB_DEPENDS+=   va.1:${PORTSDIR}/multimedia/ffmpeg
+CONFIGURE_ARGS+=        --with-hwaccel=vaapi --enable-media=ffmpeg
+.endif
+
 # NLS option processing (not sure if --disable-nls actually has any effect)
 .if !defined(WITHOUT_NLS)
 USE_GETTEXT=	yes
diff -ruN graphics/gnash-devel/distinfo graphics/gnash-devel.new/distinfo
--- graphics/gnash-devel/distinfo	2010-02-21 09:47:28.000000000 -0600
+++ graphics/gnash-devel.new/distinfo	2011-04-12 23:23:35.000000000 -0500
@@ -1,3 +1,2 @@
-MD5 (gnash-trunk-11957.tar.bz2) = 4fb470b193c4ef446c501e441678c8a3
-SHA256 (gnash-trunk-11957.tar.bz2) = 1c3a68838baca48cba686c91615a5f1e5a40d0fb62d6dae7201db94d713b11cd
-SIZE (gnash-trunk-11957.tar.bz2) = 4463437
+SHA256 (gnash-0.8.9.tar.bz2) = f90dbdc6f03d787b239b9edacbea077b46d69ae9d85f08af23f256af389c48bd
+SIZE (gnash-0.8.9.tar.bz2) = 3777140
diff -ruN graphics/gnash-devel/files/patch-plugin-klash-klash_part.cpp graphics/gnash-devel.new/files/patch-plugin-klash-klash_part.cpp
--- graphics/gnash-devel/files/patch-plugin-klash-klash_part.cpp	2010-02-20 13:41:41.000000000 -0600
+++ graphics/gnash-devel.new/files/patch-plugin-klash-klash_part.cpp	1969-12-31 18:00:00.000000000 -0600
@@ -1,11 +0,0 @@
---- plugin/klash/klash_part.cpp.orig	2009-03-02 18:29:45.000000000 +0300
-+++ plugin/klash/klash_part.cpp	2009-03-06 05:27:45.000000000 +0300
-@@ -160,7 +160,7 @@
-     QString procname;
-     char *gnash_env = getenv("KLASH_PLAYER");
-     if (!gnash_env) {
--      procname = GNASHBINDIR "/kde-gnash";
-+      procname = GNASHBINDIR "/kde3-gnash";
-     } else {
-       procname = gnash_env;
-     }
diff -ruN graphics/gnash-devel/files/patch-plugin-klash4-klash_part.cpp graphics/gnash-devel.new/files/patch-plugin-klash4-klash_part.cpp
--- graphics/gnash-devel/files/patch-plugin-klash4-klash_part.cpp	2010-02-20 13:41:41.000000000 -0600
+++ graphics/gnash-devel.new/files/patch-plugin-klash4-klash_part.cpp	1969-12-31 18:00:00.000000000 -0600
@@ -1,11 +0,0 @@
---- plugin/klash4/klash_part.cpp.orig	2009-03-02 18:29:50.000000000 +0300
-+++ plugin/klash4/klash_part.cpp	2009-03-06 05:44:08.000000000 +0300
-@@ -147,7 +147,7 @@
-         }
-     }
-     KParts::Part::setWidget (new KlashView (wparent));
--    setXMLFile("klashpartui.rc");
-+    setXMLFile("klash/klashpartui.rc");
-     setProgressInfoEnabled (false);
- 
-     if (m_fullscreen)
diff -ruN graphics/gnash-devel/files/patch-utilities-dumpshm.cpp graphics/gnash-devel.new/files/patch-utilities-dumpshm.cpp
--- graphics/gnash-devel/files/patch-utilities-dumpshm.cpp	2010-02-21 09:47:28.000000000 -0600
+++ graphics/gnash-devel.new/files/patch-utilities-dumpshm.cpp	1969-12-31 18:00:00.000000000 -0600
@@ -1,20 +0,0 @@
---- utilities/dumpshm.cpp.orig	2010-02-11 02:20:23.000000000 +0300
-+++ utilities/dumpshm.cpp	2010-02-18 22:26:30.000000000 +0300
-@@ -316,12 +316,12 @@
-         }
- #ifdef IPC_PERM_KEY
-         if (shmseg.shm_segsz == 64528) {
--            log_debug(_("Found it! \"set LCShmKey %s\" in your ~/.gnashrc",
-+            log_debug(_("Found it! \"set LCShmKey %s\" in your ~/.gnashrc"),
-                         boost::io::group(hex, showbase,
--                            shmseg.shm_perm.IPC_PERM_KEY)));
--            log_debug(_("Last changed on: %s", ctime(&shmseg.shm_ctime)));
--            log_debug(_("Last attached on: %s", ctime(&shmseg.shm_atime)));
--            log_debug(_("Last detached on: %s", ctime(&shmseg.shm_dtime)));
-+                            shmseg.shm_perm.IPC_PERM_KEY));
-+            log_debug(_("Last changed on: %s"), ctime(&shmseg.shm_ctime));
-+            log_debug(_("Last attached on: %s"), ctime(&shmseg.shm_atime));
-+            log_debug(_("Last detached on: %s"), ctime(&shmseg.shm_dtime));
-             return shmseg.shm_perm.IPC_PERM_KEY;
-         }
- #endif    // end of IPC_PERM_KEY
diff -ruN graphics/gnash-devel/pkg-plist graphics/gnash-devel.new/pkg-plist
--- graphics/gnash-devel/pkg-plist	2010-02-21 09:47:28.000000000 -0600
+++ graphics/gnash-devel.new/pkg-plist	2011-04-13 00:00:54.000000000 -0500
@@ -1,9 +1,7 @@
 %%GSTREAMER%%bin/findmicrophones
 %%GSTREAMER%%bin/findwebcams
-bin/flvdumper
 bin/gnash
 bin/gprocessor
-bin/soldumper
 %%GTK%%bin/gtk-gnash
 %%KDE%%bin/kde3-gnash
 %%KDE4%%bin/kde4-gnash
@@ -15,238 +13,76 @@
 @comment Should be //KPARTS//, but it is installed regardless of whether plugin is enabled
 %%KPARTS%%share/services/klash_part.desktop
 include/gnash/AMF.h
-include/gnash/AVM1Movie_as.h
-include/gnash/AccessibilityProperties_as.h
-include/gnash/Accessibility_as.h
-include/gnash/ActionScriptVersion_as.h
-include/gnash/ActivityEvent_as.h
-include/gnash/AntiAliasType_as.h
-include/gnash/ApplicationDomain_as.h
-include/gnash/Array_as.h
-include/gnash/AsyncErrorEvent_as.h
 include/gnash/BevelFilter_as.h
-include/gnash/BitmapDataChannel_as.h
-include/gnash/BitmapFilterQuality_as.h
-include/gnash/BitmapFilterType_as.h
 include/gnash/BitmapFilter_as.h
-include/gnash/BitmapInfo.h
-include/gnash/Bitmap_as.h
-include/gnash/BlendMode_as.h
 include/gnash/BlurFilter_as.h
-include/gnash/ByteArray_as.h
-include/gnash/CSMSettings_as.h
-include/gnash/CallStack.h
-include/gnash/Camera_as.h
-include/gnash/Capabilities_as.h
-include/gnash/CapsStyle_as.h
-include/gnash/CharacterProxy.h
-include/gnash/ClipboardFormats_as.h
-include/gnash/ClipboardTransferMode_as.h
-include/gnash/Clipboard_as.h
 include/gnash/ColorMatrixFilter_as.h
 include/gnash/ColorTransform_as.h
-include/gnash/ContextMenuBuiltInItems_as.h
-include/gnash/ContextMenuEvent_as.h
-include/gnash/ContextMenuItem_as.h
-include/gnash/ContextMenu_as.h
-include/gnash/ControlTag.h
+include/gnash/BitmapData_as.h
+include/gnash/BitsReader.h
+include/gnash/CachedBitmap.h
+include/gnash/ClockTime.h
+include/gnash/GnashAlgorithm.h
+include/gnash/GnashEnums.h
+include/gnash/GnashFactory.h
+include/gnash/GnashFileUtilities.h
+include/gnash/GnashNumeric.h
+include/gnash/GnashSleep.h
+include/gnash/GnashSystemFDHeaders.h
+include/gnash/GnashSystemIOHeaders.h
+include/gnash/GnashSystemNetHeaders.h
+include/gnash/IOChannel.h
+include/gnash/ImageIterators.h
+include/gnash/RTMP.h
+include/gnash/Renderer.h
+include/gnash/SWFCtype.h
+include/gnash/SharedMem.h
+include/gnash/SimpleBuffer.h
+include/gnash/Socket.h
+include/gnash/Stats.h
+include/gnash/URLAccessManager.h
+include/gnash/WallClockTimer.h
+include/gnash/accumulator.h
+include/gnash/arg_parser.h
+include/gnash/extension.h
+include/gnash/getclocktime.hpp
+include/gnash/gmemory.h
+include/gnash/jemtree.h
+include/gnash/noseek_fd_adapter.h
+include/gnash/sharedlib.h
+include/gnash/tree.hh
+include/gnash/tu_file.h
+include/gnash/utf8.h
+include/gnash/zlib_adapter.h
 include/gnash/ConvolutionFilter_as.h
-include/gnash/DataEvent_as.h
-include/gnash/DefinitionTag.h
-include/gnash/DeleteObjectSample_as.h
-include/gnash/Dictionary_as.h
-include/gnash/DisplacementMapFilterMode_as.h
 include/gnash/DisplacementMapFilter_as.h
-include/gnash/DisplayList.h
-include/gnash/DisplayObject.h
-include/gnash/DisplayObjectContainer.h
-include/gnash/DisplayObjectContainer_as.h
-include/gnash/DisplayObject_as.h
 include/gnash/DropShadowFilter_as.h
-include/gnash/DynamicShape.h
-include/gnash/EOFError_as.h
-include/gnash/Endian_as.h
-include/gnash/ErrorEvent_as.h
-include/gnash/EventDispatcher_as.h
-include/gnash/EventPhase_as.h
-include/gnash/Event_as.h
-include/gnash/ExportableResource.h
 include/gnash/ExternalInterface_as.h
-include/gnash/FileFilter_as.h
-include/gnash/FileTypes.h
-include/gnash/FocusEvent_as.h
-include/gnash/FontStyle_as.h
-include/gnash/FontType_as.h
-include/gnash/Font_as.h
-include/gnash/FrameLabel_as.h
-include/gnash/FullScreenEvent_as.h
 include/gnash/GC.h
-include/gnash/Geometry.h
 include/gnash/GlowFilter_as.h
 include/gnash/GnashException.h
 include/gnash/GnashImage.h
 include/gnash/GnashImageJpeg.h
-include/gnash/GnashKey.h
 include/gnash/GradientBevelFilter_as.h
 include/gnash/GradientGlowFilter_as.h
-include/gnash/GradientType_as.h
-include/gnash/Graphics_as.h
-include/gnash/GridFitType_as.h
-include/gnash/HTTPStatusEvent_as.h
-include/gnash/IBitmapDrawable_as.h
-include/gnash/ID3Info_as.h
-include/gnash/IDataInput_as.h
-include/gnash/IDataOutput_as.h
-include/gnash/IDynamicPropertyOutput_as.h
-include/gnash/IDynamicPropertyWriter_as.h
-include/gnash/IEventDispatcher_as.h
-include/gnash/IExternalizable_as.h
-include/gnash/IMEConversionMode_as.h
-include/gnash/IMEEvent_as.h
-include/gnash/IME_as.h
-include/gnash/IOErrorEvent_as.h
-include/gnash/IOError_as.h
-include/gnash/IllegalOperationError_as.h
-include/gnash/InteractiveObject.h
-include/gnash/InteractiveObject_as.h
-include/gnash/InterpolationMethod_as.h
-include/gnash/InvalidSWFError_as.h
-include/gnash/JointStyle_as.h
-include/gnash/KeyLocation_as.h
-include/gnash/KeyboardEvent_as.h
-include/gnash/Keyboard_as.h
-include/gnash/LineScaleMode_as.h
-include/gnash/LineStyle.h
-include/gnash/LoaderContext_as.h
-include/gnash/LoaderInfo_as.h
-include/gnash/Loader_as.h
-include/gnash/LocalConnection_as.h
-include/gnash/Machine.h
 include/gnash/Matrix_as.h
-include/gnash/MemoryError_as.h
-include/gnash/Microphone_as.h
-include/gnash/MorphShape_as.h
-include/gnash/MouseButtonState.h
-include/gnash/MouseEvent_as.h
-include/gnash/Mouse_as.h
-include/gnash/Movie.h
-include/gnash/MovieClip.h
-include/gnash/MovieClip_as.h
-include/gnash/MovieFactory.h
 include/gnash/NamingPolicy.h
-include/gnash/NativeFunction.h
-include/gnash/NetConnection_as.h
-include/gnash/NetStatusEvent_as.h
-include/gnash/NetStream_as.h
 include/gnash/NetworkAdapter.h
-include/gnash/NewObjectSample_as.h
-include/gnash/ObjectEncoding_as.h
-include/gnash/ObjectURI.h
-include/gnash/PixelSnapping_as.h
 include/gnash/Point2d.h
 include/gnash/Point_as.h
-include/gnash/PrintJobOptions_as.h
-include/gnash/PrintJobOrientation_as.h
-include/gnash/PrintJob_as.h
-include/gnash/ProgressEvent_as.h
-include/gnash/PropFlags.h
-include/gnash/Property.h
-include/gnash/PropertyList.h
-include/gnash/Proxy_as.h
-include/gnash/RGBA.h
 include/gnash/Range2d.h
 include/gnash/Rectangle_as.h
-include/gnash/Relay.h
-include/gnash/Responder_as.h
-include/gnash/RunResources.h
-include/gnash/SWF.h
-include/gnash/SWFMatrix.h
-include/gnash/SWFRect.h
-include/gnash/SWFVersion_as.h
-include/gnash/SafeStack.h
-include/gnash/Sample_as.h
-include/gnash/Scene_as.h
-include/gnash/ScriptTimeoutError_as.h
-include/gnash/SecurityDomain_as.h
-include/gnash/SecurityErrorEvent_as.h
-include/gnash/SecurityPanel_as.h
-include/gnash/Security_as.h
-include/gnash/ShapeRecord.h
-include/gnash/Shape_as.h
-include/gnash/SharedObjectFlushStatus_as.h
-include/gnash/SharedObject_as.h
-include/gnash/SimpleButton_as.h
-include/gnash/Socket_as.h
-include/gnash/SoundChannel_as.h
-include/gnash/SoundLoaderContext_as.h
-include/gnash/SoundMixer_as.h
-include/gnash/SoundTransform_as.h
-include/gnash/Sound_as.h
-include/gnash/SpreadMethod_as.h
-include/gnash/Sprite_as.h
-include/gnash/StackFrame_as.h
-include/gnash/StackOverflowError_as.h
-include/gnash/StageAlign_as.h
-include/gnash/StageDisplayState_as.h
-include/gnash/StageQuality_as.h
-include/gnash/StageScaleMode_as.h
-include/gnash/Stage_as.h
-include/gnash/StaticText_as.h
-include/gnash/StatusEvent_as.h
 include/gnash/StreamProvider.h
 include/gnash/StringPredicates.h
-include/gnash/StyleSheet_as.h
-include/gnash/SyncEvent_as.h
-include/gnash/System_as.h
-include/gnash/TagLoadersTable.h
-include/gnash/TextColorType_as.h
-include/gnash/TextDisplayMode_as.h
-include/gnash/TextEvent_as.h
-include/gnash/TextFieldAutoSize_as.h
-include/gnash/TextFieldType_as.h
-include/gnash/TextField_as.h
-include/gnash/TextFormatAlign_as.h
-include/gnash/TextFormat_as.h
-include/gnash/TextLineMetrics_as.h
-include/gnash/TextSnapshot_as.h
-include/gnash/TimerEvent_as.h
-include/gnash/Timer_as.h
 include/gnash/Transform_as.h
 include/gnash/URL.h
-include/gnash/URLLoaderDataFormat_as.h
-include/gnash/URLLoader_as.h
-include/gnash/URLRequestHeader_as.h
-include/gnash/URLRequestMethod_as.h
-include/gnash/URLRequest_as.h
-include/gnash/URLStream_as.h
-include/gnash/URLVariables_as.h
-include/gnash/VM.h
-include/gnash/Video.h
-include/gnash/Video_as.h
-include/gnash/XMLDocument_as.h
-include/gnash/XMLNode_as.h
-include/gnash/XMLSocket_as.h
-include/gnash/as_environment.h
-include/gnash/as_function.h
-include/gnash/as_object.h
-include/gnash/as_value.h
-include/gnash/builtin_function.h
-include/gnash/cxform.h
 include/gnash/display_pkg.h
-include/gnash/drag_state.h
 include/gnash/dsodefs.h
-include/gnash/event_id.h
 include/gnash/external_pkg.h
-include/gnash/fill_style.h
 include/gnash/filters_pkg.h
-include/gnash/fn_call.h
 include/gnash/geom_pkg.h
 include/gnash/gettext.h
-include/gnash/gnash.h
 include/gnash/log.h
-include/gnash/movie_definition.h
-include/gnash/movie_root.h
-include/gnash/namedStrings.h
 include/gnash/net_pkg.h
 include/gnash/rc.h
 include/gnash/ref_counted.h
@@ -255,13 +91,101 @@
 include/gnash/string_table.h
 include/gnash/text_pkg.h
 include/gnash/utility.h
+include/gnash/asobj/AMFConverter.h
+include/gnash/asobj/ASConversions.h
+include/gnash/asobj/Accessibility_as.h
+include/gnash/asobj/Array_as.h
+include/gnash/asobj/AsBroadcaster.h
+include/gnash/asobj/Boolean_as.h
+include/gnash/asobj/Camera_as.h
+include/gnash/asobj/CharacterProxy.h
+include/gnash/asobj/Color_as.h
+include/gnash/asobj/ContextMenuItem_as.h
+include/gnash/asobj/ContextMenu_as.h
+include/gnash/asobj/ControlTag.h
+include/gnash/asobj/Date_as.h
+include/gnash/asobj/DefinitionTag.h
+include/gnash/asobj/DisplayList.h
+include/gnash/asobj/DisplayObject.h
+include/gnash/asobj/DisplayObjectContainer.h
+include/gnash/asobj/DragState.h
+include/gnash/asobj/DynamicShape.h
+include/gnash/asobj/Error_as.h
+include/gnash/asobj/FillStyle.h
+include/gnash/asobj/Function_as.h
+include/gnash/asobj/Geometry.h
+include/gnash/asobj/Global_as.h
+include/gnash/asobj/GnashKey.h
+include/gnash/asobj/InteractiveObject.h
+include/gnash/asobj/Key_as.h
+include/gnash/asobj/LineStyle.h
+include/gnash/asobj/LoadVars_as.h
+include/gnash/asobj/LoadableObject.h
+include/gnash/asobj/LocalConnection_as.h
+include/gnash/asobj/Math_as.h
+include/gnash/asobj/Microphone_as.h
+include/gnash/asobj/MouseButtonState.h
+include/gnash/asobj/Mouse_as.h
+include/gnash/asobj/Movie.h
+include/gnash/asobj/MovieClip.h
+include/gnash/asobj/MovieClipLoader.h
+include/gnash/asobj/MovieClip_as.h
+include/gnash/asobj/MovieFactory.h
+include/gnash/asobj/NativeFunction.h
+include/gnash/asobj/NetConnection_as.h
+include/gnash/asobj/NetStream_as.h
+include/gnash/asobj/Number_as.h
+include/gnash/asobj/Object.h
+include/gnash/asobj/ObjectURI.h
+include/gnash/asobj/PlayHead.h
+include/gnash/asobj/PropFlags.h
+include/gnash/asobj/Property.h
+include/gnash/asobj/PropertyList.h
+include/gnash/asobj/RGBA.h
+include/gnash/asobj/Relay.h
+include/gnash/asobj/RunResources.h
+include/gnash/asobj/SWF.h
+include/gnash/asobj/SWFCxForm.h
+include/gnash/asobj/SWFMatrix.h
+include/gnash/asobj/SWFRect.h
+include/gnash/asobj/Selection_as.h
+include/gnash/asobj/ShapeRecord.h
+include/gnash/asobj/SharedObject_as.h
+include/gnash/asobj/Sound_as.h
+include/gnash/asobj/Stage_as.h
+include/gnash/asobj/String_as.h
+include/gnash/asobj/System_as.h
+include/gnash/asobj/TagLoadersTable.h
+include/gnash/asobj/TextField_as.h
+include/gnash/asobj/TextFormat_as.h
+include/gnash/asobj/TextSnapshot_as.h
+include/gnash/asobj/UserFunction.h
+include/gnash/asobj/Video.h
+include/gnash/asobj/XMLNode_as.h
+include/gnash/asobj/XMLSocket_as.h
+include/gnash/asobj/XML_as.h
+include/gnash/asobj/as_environment.h
+include/gnash/asobj/as_function.h
+include/gnash/asobj/as_object.h
+include/gnash/asobj/as_value.h
+include/gnash/asobj/builtin_function.h
+include/gnash/asobj/event_id.h
+include/gnash/asobj/movie_root.h
+include/gnash/asobj/namedStrings.h
+include/gnash/parser/movie_definition.h
+include/gnash/vm/ASHandlers.h
+include/gnash/vm/ActionExec.h
+include/gnash/vm/CallStack.h
+include/gnash/vm/ExecutableCode.h
+include/gnash/vm/SafeStack.h
+include/gnash/vm/VM.h
+include/gnash/vm/fn_call.h
 %%KPARTS%%lib/kde3/libklashpart.so
 %%KPARTS%%lib/kde3/libklashpart.la
 %%KPARTS4%%kde4/share/apps/klash/pluginsinfo
 %%KPARTS4%%kde4/share/apps/klash/klashpartui.rc
 %%KPARTS4%%kde4/share/kde4/services/klash_part.desktop
 %%KPARTS4%%kde4/lib/kde4/libklashpart.so
-%%KPARTS4%%kde4/lib/kde4/libklashpart.la
 %%CYGNAL%%@unexec if cmp -s %D/etc/cygnalrc.dist %D/etc/cygnalrc; then rm -f %D/etc/cygnalrc; fi
 %%CYGNAL%%etc/cygnalrc.dist
 %%CYGNAL%%@exec if [ ! -f %B/cygnalrc ]; then cp -p %D/%F %B/cygnalrc; fi
@@ -273,37 +197,26 @@
 @exec if [ ! -f %B/gnashrc ]; then cp -p %D/%F %B/gnashrc; fi
 %%CYGNAL%%lib/cygnal/plugins/echo.so
 %%CYGNAL%%lib/cygnal/plugins/oflaDemo.so
-lib/gnash/libgnashamf-%%GNASHVER%%.so
-lib/gnash/libgnashamf.la
-lib/gnash/libgnashamf.so
-%%AGG%%lib/gnash/libgnashagg.la
-%%AGG%%lib/gnash/libgnashagg.so
-%%AGG%%lib/gnash/libgnashagg.so.0
+lib/gnash/libgnashrender-0.8.9.so
+lib/gnash/libgnashrender.so
+lib/gnash/libgnashvaapi-0.8.9.so
+lib/gnash/libgnashvaapi.la
+lib/gnash/libgnashvaapi.so
 lib/gnash/libgnashbase-%%GNASHVER%%.so
-lib/gnash/libgnashbase.la
 lib/gnash/libgnashbase.so
 lib/gnash/libgnashcore-%%GNASHVER%%.so
-lib/gnash/libgnashcore.la
 lib/gnash/libgnashcore.so
 lib/gnash/libgnashmedia-%%GNASHVER%%.so
-lib/gnash/libgnashmedia.la
 lib/gnash/libgnashmedia.so
-lib/gnash/libgnashnet.la
-lib/gnash/libgnashnet.so
-lib/gnash/libgnashnet.so.0
 lib/gnash/libgnashsound-%%GNASHVER%%.so
-lib/gnash/libgnashsound.la
 lib/gnash/libgnashsound.so
-%%NPAPI%%lib/gnash/libmozsdk.la
-%%NPAPI%%lib/gnash/libmozsdk.so
-%%NPAPI%%lib/gnash/libmozsdk.so.0
 libdata/pkgconfig/gnash.pc
-%%DOCSDIR%%/gnashuser.html
-%%DOCSDIR%%/images/car_crash.png
-%%DOCSDIR%%/images/rtmp.png
-%%DOCSDIR%%/gnashref.html
 %%DATADIR%%/GnashG.png
+%%DATADIR%%/gnash-splash.swf
 %%DATADIR%%/gnash_128_96.ico
+%%DATADIR%%/doc/gnash/C/gnashref.html
+%%DATADIR%%/doc/gnash/C/gnashuser.html
+%%DATADIR%%/doc/gnash/C/images/rtmp.png
 share/locale/cs/LC_MESSAGES/gnash.mo
 share/locale/de/LC_MESSAGES/gnash.mo
 share/locale/es/LC_MESSAGES/gnash.mo
@@ -311,12 +224,17 @@
 share/locale/fr/LC_MESSAGES/gnash.mo
 share/locale/it/LC_MESSAGES/gnash.mo
 share/locale/ja/LC_MESSAGES/gnash.mo
+@dirrm %%DATADIR%%/doc/gnash/C/images
+@dirrm %%DATADIR%%/doc/gnash/C
+@dirrm %%DATADIR%%/doc/gnash
+@dirrm %%DATADIR%%/doc
 @dirrm %%DATADIR%%
-@dirrm %%DOCSDIR%%/images
-@dirrm %%DOCSDIR%%
 @dirrm lib/gnash
 %%CYGNAL%%@dirrm lib/cygnal/plugins
 %%CYGNAL%%@dirrm lib/cygnal
+@dirrm include/gnash/asobj
+@dirrm include/gnash/parser
+@dirrm include/gnash/vm
 @dirrm include/gnash
 @comment Should be //KPARTS//, but it is installed regardless of whether plugin is enabled
 %%KPARTS%%@dirrm share/apps/klash